import os
import random
import pathlib
# link to the program on my web
# http://thaiiceland.is/apps/thaiiceland-xml-creator.py.zip

print("\n\nThis program will shufle and rename all the images in the selected image folder.\n The folder must only contain images (not other files).")
print("Then the program will write a XML file to make changable backgrounds images.\n\n")
# 1. background abslute path
#pathToFolder='/home/thaiiceland/Pictures/Background/selected/'
pathToFolder=input("\nType the link to the image folder.\n  (have to be a relative link (images)\n ")
absolutPath=os.path.abspath(os.getcwd())+"/"
os.chdir(pathToFolder)
pathToFolder=pathToFolder+"/"

# 2. input fields
# and to make string for xml file
slideDuration=input("\nType in how many mintes between images to show.\n ")
slideDuration=str(int(slideDuration)*60)+".0"
transitionDuration=input("\nType in how many seconds in transition while changing images.\n ")+".0"
destinationXML=input("\nType in name of the destination XML file (pureos, mybacgrounds...),\n the program will automaticly generate the .xml ending\n  (if file exist it will be overwrited)\n ")+".xml"

print("\n\nExecuting your XML-file.\n When the file is ready, you can replace the pureos.xml file\n in /usr/share/backgrounds/pureos/pureos.xml")
print(" with this xml file (you have to keep the same name as in the\n /usr/share/backgrounds/pureos/...xml-file)")
print(" You will need to have administrator privilege (sudo) to do that.\n")

# 3. to prevent pictures names will be overwrite on each picture and end up with only one picture
#    first I will rename all picture to something unlikely name
mylist = ["A","B","C","D","E","F","G","H","I","J","K","T"]
i=0
for file in os.listdir():
  #isDirectory = os.path.isdir(file)
  #isFile = os.path.isfile(file)
  src=file
  if not os.path.isfile(file):
    continue
  extension = pathlib.Path(file).suffix
  dst="bbafsaffaaccar"+random.choice(mylist)+"-"+str(i)+extension
  os.rename(src,dst)
  i+=1
#print(i)

# 4. rename images again and make xml file
pstring="<!-- for things to work in PureOs, need to copy code to /usr/share/backgrounds/pureos.xml -->\n"
pstring+="<background>\n<starttime>\n<hour>0</hour>\n<minute>00</minute>\n<second>01</second>\n</starttime>\n"
pstring+="<!-- this creates an arbitrary start time of 12 am -->\n"

i=0
changeToName="background-"
pictureNo=len([items for items in os.scandir() if os.path.isfile(items)])-1
firstExtesion=""
oldFile=""
for file in os.listdir():
  #isDirectory = os.path.isdir(file)
  #isFile = os.path.isfile(file)
  src=file
  if not os.path.isfile(file):
    continue
  extension = pathlib.Path(file).suffix
  dst=changeToName+str(i)+extension
  os.rename(src,dst)
  if i==0:
    firstExtesion=extension
    pstring+="<static>\n<duration>"+slideDuration+"</duration>\n<file>"+absolutPath+pathToFolder+dst+"</file>\n</static>\n"
  elif i==pictureNo:
    pstring+="<transition>\n<duration>"+transitionDuration+"</duration>\n<from>"+absolutPath+pathToFolder+oldFile+"</from>\n"
    pstring+="<to>"+absolutPath+pathToFolder+dst+"</to>\n</transition>\n"
    pstring+="<static>\n<duration>"+slideDuration+"</duration>\n<file>"+absolutPath+pathToFolder+dst+"</file>\n</static>\n"
    pstring+="<transition>\n<duration>"+transitionDuration+"</duration>\n<from>"+absolutPath+pathToFolder+dst+"</from>\n"
    pstring+="<to>"+absolutPath+pathToFolder+changeToName+"0"+firstExtesion+"</to>\n</transition>\n"
  else:
    pstring+="<transition>\n<duration>"+transitionDuration+"</duration>\n<from>"+absolutPath+pathToFolder+oldFile+"</from>\n"
    pstring+="<to>"+absolutPath+pathToFolder+dst+"</to>\n</transition>\n"
    pstring+="<static>\n<duration>"+slideDuration+"</duration>\n<file>"+absolutPath+pathToFolder+dst+"</file>\n</static>\n"
  oldFile=dst
  i+=1

pstring+="</background>"
#print(pstring)

os.chdir('..')
with open(destinationXML, 'w') as writer:
  writer.write(pstring)
